# numberwords.py
# --------------
# By MWC Contributors
# Functions to print out a verbal representation of an integer.

MAXIMUM = 1000000
DIGIT_NAMES = [
    "zero", "one", "two", "three", "four", "five", "six", "seven", "eight", "nine"
]
TWEEN_AND_TEEN_NAMES = [
    "ten", "eleven", "twelve", "thirteen", "fourteen", "fifteen", "sixteen", "seventeen", "eighteen", "nineteen"
]
TENS_NAMES = [
    "", "ten", "twenty", "thirty", "forty", "fifty", "sixty", "seventy", "eighty", "ninety"
]

def int_under_1000000_to_str(number):
    if number<1000:
        return int_under_1000_to_str(number)
    quotient,remainder=divide_with_remainder(number,1000)
    Q1=int_under_1000_to_str(quotient) + " " + "thousand"
    if remainder>0:
        R1=int_under_1000_to_str(remainder)
        return Q1 + " " + R1
    return Q1
        
def int_under_1000_to_str(number):
    if number<100:
        return int_under_100_to_str(number)
    quotient,remainder=divide_with_remainder(number,100)
    Q1=int_under_10_to_str(quotient) + " " + "hundred"
    if remainder>0:
        R1=int_under_100_to_str(remainder)
        return Q1 + " and " + R1
    return Q1

def int_under_100_to_str(number):
    if number<20:
        return int_under_20_to_str(number)
    quotient,remainder=divide_with_remainder(number,10)
    tensname=TENS_NAMES[quotient]
    if remainder>0:
        onesname=int_under_10_to_str(remainder)
        return tensname + "-" + onesname
    return tensname

def int_under_20_to_str(number):
    if number<10:
        return int_under_10_to_str(number)
    return TWEEN_AND_TEEN_NAMES[number-10]

def int_under_10_to_str(number):
    return DIGIT_NAMES[number]

def divide_with_remainder(dividend, divisor):
    """Divides one number by another, using whole-number division. 
    Returns the quotient and the remainder. 
    """
    quotient = dividend // divisor
    remainder = dividend % divisor
    return quotient, remainder
